"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var child_process_1 = require("child_process");
var path_1 = tslib_1.__importDefault(require("path"));
/**
 * Increaase UV_THREADPOOL_SIZE to prevent deadlock in SCSS compilation
 * https://github.com/webpack-contrib/sass-loader/issues/100
 */
process.env.UV_THREADPOOL_SIZE = '128';
var filePath = path_1.default.resolve(__dirname, 'index.js');
var env = tslib_1.__assign({}, process.env);
// already set fast mode env variable here so that the server build also skips type checking
if ((process.argv.indexOf('watch') !== -1 && process.argv.indexOf('fast') !== -1) ||
    process.argv.indexOf('build') !== -1) {
    env.START_FAST_MODE = 'true'; // fast mode when building
}
var proc = child_process_1.fork(filePath, process.argv.slice(2), {
    env: env,
    execArgv: process.execArgv.concat([
        // Node runs out of memory when re-exporting the glamorous 4 typings
        // with TypeScript 2.4
        // https://github.com/Microsoft/TypeScript/issues/17070
        '--max-old-space-size=4096',
    ]),
});
proc.on('error', function () {
    process.exit(1);
});
proc.on('exit', function (code) {
    process.exit(code);
});
//# sourceMappingURL=_pwt.js.map