import { BuildConfig } from 'lib/runtime/server';
import { Logger } from 'typescript-log';
import webpack from 'webpack';
import { BuildParam } from '../types';
export declare function smp(buildConfig: BuildConfig, webpackConfig: webpack.Configuration): webpack.Configuration;
/**
 * Builds one or all targets in a specified environment
 * @param args
 *  [<target>] [<environment>] [-p <project root>]
 *  - target defaults to both server and client
 *  - environment defaults to prod
 *  - p: the root of the build, used for config discovery
 */
declare const build: (log: Logger, buildConfig: BuildConfig, ...args: BuildParam[]) => Promise<void>;
export default build;
