/// <reference types="node" />
import { ChildProcess } from 'child_process';
import { BuildConfig } from 'lib/runtime/server';
import { Logger } from 'typescript-log';
import { WatchParam } from '../types';
import { WatchServer } from '../watch/server';
/**
 * Rebuilds the client on changes
 * @param args
 * - server: Also watches and rebuilds server
 * - fast: disables type checking
 * - client: Only run client without a server
 */
declare const watch: (log: Logger, buildConfig: BuildConfig, watchProcessEnv: NodeJS.ProcessEnv, ...args: WatchParam[]) => Promise<ChildProcess | WatchServer>;
export default watch;
