"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rimraf_1 = tslib_1.__importDefault(require("rimraf"));
var clean = function (log, paths) {
    if (Array.isArray(paths)) {
        return Promise.all(paths.map(function (path) { return clean(log, path); }));
    }
    return new Promise(function (resolve, reject) {
        rimraf_1.default(paths, function (err) {
            if (err) {
                log.error({ err: err }, 'Clean error');
                reject(err);
            }
            else {
                resolve();
            }
        });
    });
};
exports.default = clean;
//# sourceMappingURL=index.js.map