"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var webpack_1 = tslib_1.__importDefault(require("webpack"));
var webpack_merge_1 = tslib_1.__importDefault(require("webpack-merge"));
var webpack_hooks_1 = tslib_1.__importStar(require("./webpack-hooks"));
var webpack_base_1 = tslib_1.__importDefault(require("./webpack.base"));
var webpack_client_1 = tslib_1.__importDefault(require("./webpack.client"));
var webpack_dev_1 = tslib_1.__importDefault(require("./webpack.dev"));
/** Webpack config for the client in development */
var config = function (options) {
    var webpackHooks = webpack_hooks_1.default(options.log, options.buildConfig.BASE);
    return webpack_merge_1.default(webpack_base_1.default(options), webpack_hooks_1.getHook(webpackHooks.base, options), webpack_client_1.default(options), webpack_hooks_1.getHook(webpackHooks.client, options), webpack_dev_1.default, webpack_hooks_1.getHook(webpackHooks.dev, options), {
        entry: {
            main: ['webpack-hot-middleware/client?noInfo=true'],
        },
        output: {
            chunkFilename: options.buildConfig.ASSETS_PATH_PREFIX + 'js/[name].js',
            filename: options.buildConfig.ASSETS_PATH_PREFIX + 'js/[name].js',
        },
        plugins: [new webpack_1.default.HotModuleReplacementPlugin()],
    }, webpack_hooks_1.getHook(webpackHooks.clientDev, options));
};
exports.default = config;
//# sourceMappingURL=webpack.client.dev.js.map