"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var react_helmet_1 = require("react-helmet");
var react_router_dom_1 = require("react-router-dom");
var universal_1 = require("../../universal");
function renderApp(currentLocation, renderFn, log, appRender, promiseTracker) {
    // first create a context for <StaticRouter>, it's where we keep the
    // results of rendering for the second pass if necessary
    var context = {};
    var renderResult;
    var head;
    try {
        renderResult = universal_1.functionTimer('Server side render', function () {
            return renderFn(react_1.default.createElement(react_router_dom_1.StaticRouter, { location: currentLocation, context: context }, appRender(promiseTracker)));
        }, log);
    }
    finally {
        head = react_helmet_1.Helmet.rewind();
    }
    return {
        context: context,
        head: head,
        renderResult: renderResult,
    };
}
exports.renderApp = renderApp;
//# sourceMappingURL=render-app-to-string.js.map