"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var history_1 = require("history");
var react_1 = tslib_1.__importDefault(require("react"));
var react_router_dom_1 = require("react-router-dom");
var get_transferred_state_1 = require("../../client/get-transferred-state");
var locationOverrideFromSSR = get_transferred_state_1.getTransferredState('watchtower_hydrate_location');
/**
 * A wrapper around React routers Browser router
 * It takes care of hydrating error routes if they happened on the server.
 * Other than initial hydration it does nothing additional
 */
var WatchtowerBrowserRouter = /** @class */ (function (_super) {
    tslib_1.__extends(WatchtowerBrowserRouter, _super);
    function WatchtowerBrowserRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WatchtowerBrowserRouter.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, props = tslib_1.__rest(_a, ["children"]);
        return (react_1.default.createElement(react_router_dom_1.BrowserRouter, tslib_1.__assign({}, props),
            react_1.default.createElement(react_router_dom_1.Route, { render: function (routeProps) {
                    if (!_this.initialLocation) {
                        _this.initialLocation = routeProps.location;
                    }
                    // While still on the initial route (which was hydrated), override the url
                    // if an override came from the server
                    var locationOverride = _this.initialLocation === routeProps.location && locationOverrideFromSSR
                        ? history_1.createLocation(locationOverrideFromSSR)
                        : undefined;
                    if (locationOverride) {
                        return react_1.default.createElement(react_router_dom_1.Route, { location: locationOverride }, _this.props.children);
                    }
                    return react_1.default.Children.only(_this.props.children);
                } })));
    };
    WatchtowerBrowserRouter.displayName = 'WatchtowerBrowserRouter';
    return WatchtowerBrowserRouter;
}(react_1.default.Component));
exports.WatchtowerBrowserRouter = WatchtowerBrowserRouter;
//# sourceMappingURL=watchtower-browser-router.js.map