"use strict";
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var net_1 = tslib_1.__importDefault(require("net"));
exports.waitForConnection = function (port, timeout) {
    if (timeout === void 0) { timeout = 30000; }
    return Promise.race([
        new Promise(function (resolve) {
            var connect = function () {
                var socket = net_1.default.connect({ port: port }, function () {
                    socket.end();
                    resolve();
                });
                socket.on('error', function () {
                    setTimeout(connect, 2000);
                });
            };
            connect();
        }),
        new Promise(function (resolve) { return setTimeout(function () { return resolve(); }, timeout); }),
    ]);
};
var startPort = 3000;
exports.checkPortAvailability = function (port) {
    return new Promise(function (resolve, reject) {
        var server = net_1.default.createServer();
        server.on('error', function () { return reject(); });
        server.listen(port, function () {
            server.once('close', function () { return resolve(); });
            server.close();
        });
    });
};
exports.findFreePort = function (useStartPort) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    var testPort, i, port, e_1;
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                testPort = useStartPort || startPort;
                i = 0;
                _a.label = 1;
            case 1:
                if (!(i < 100)) return [3 /*break*/, 6];
                _a.label = 2;
            case 2:
                _a.trys.push([2, 4, , 5]);
                port = testPort + i;
                return [4 /*yield*/, exports.checkPortAvailability(port)];
            case 3:
                _a.sent();
                return [2 /*return*/, port];
            case 4:
                e_1 = _a.sent();
                return [3 /*break*/, 5];
            case 5:
                i++;
                return [3 /*break*/, 1];
            case 6: throw new Error('Could not find a free port within 100 tries!');
        }
    });
}); };
//# sourceMappingURL=network.js.map