"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var assets_webpack_plugin_1 = tslib_1.__importDefault(require("assets-webpack-plugin"));
var opn_1 = tslib_1.__importDefault(require("opn"));
var webpack_1 = tslib_1.__importDefault(require("webpack"));
var webpack_dev_middleware_1 = tslib_1.__importDefault(require("webpack-dev-middleware"));
var webpack_hot_middleware_1 = tslib_1.__importDefault(require("webpack-hot-middleware"));
var build_1 = require("../build/build");
exports.getHotReloadMiddleware = function (log, buildConfig) {
    var config = build_1.getWebpackConfig(log, buildConfig, 'client', 'dev');
    if (!config) {
        throw new Error('Unable to load webpack config');
    }
    if (config.plugins) {
        config.plugins = config.plugins.filter(function (plugin) { return !(plugin instanceof assets_webpack_plugin_1.default); });
    }
    var compiler = webpack_1.default(config);
    var dev = webpack_dev_middleware_1.default(compiler, {
        // do not serve index.html on / route
        // https://github.com/webpack/webpack-dev-middleware/issues/153
        index: 'foobar',
        logLevel: 'silent',
        publicPath: buildConfig.PUBLIC_PATH,
        stats: 'errors-only',
    });
    var hot = webpack_hot_middleware_1.default(compiler);
    return [dev, hot];
};
exports.openBrowser = function (port) {
    if (process.env.NODE_ENV === 'test') {
        return;
    }
    opn_1.default("http://localhost:" + port);
};
//# sourceMappingURL=dev.js.map