import { BuildConfig } from 'lib/runtime/server';
import { Logger } from 'typescript-log';
export interface SSRStats {
    size: number;
    time: number;
    content: string;
}
export declare const loadSSRPage: (url: string) => Promise<SSRStats>;
export interface StatsRunDetails {
    page: string;
    urlPath: string;
    url: string;
    port: number;
}
export declare type StatsFn = (details: StatsRunDetails) => Promise<any>;
export declare const runStatsOnServer: (log: Logger, buildConfig: BuildConfig, statsFn: StatsFn, verbose?: boolean) => Promise<void>;
