"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.prettyJson = function (obj) { return JSON.stringify(obj, undefined, 2); };
// tslint:disable:no-console
var log = function (method, args) {
    if (args.length === 0) {
        return;
    }
    if (typeof args[0] === 'string') {
        return console[method](args[0]);
    }
    console[method](exports.prettyJson(args[1]), args[0]);
};
/** Logger interface compatible console logger, does't log level info in message */
exports.cliLogger = {
    child: function () { return exports.cliLogger; },
    debug: function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return log('debug', args);
    },
    error: function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return log('error', args);
    },
    fatal: function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return log('error', args);
    },
    info: function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return log('log', args);
    },
    trace: function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return log('trace', args);
    },
    warn: function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return log('warn', args);
    },
};
//# sourceMappingURL=log.js.map