/// <reference types="node" />
import { ChildProcess } from 'child_process';
import { BuildConfig } from 'lib/runtime/server';
import { Logger } from 'typescript-log';
import { StartParam } from '../types';
/**
 * Starts the pre-built server with the environment variables
 * defined in `.env`
 * @param args
 * - watch: Enables watch mode
 * - fast: Disables server-side rendering and type checking
 * - prod: Sets NODE_ENV to "production"
 * - debug: Starts with debugging enabled
 * - debug-brk: Starts with debugging and waits for debugger to attach
 * - --debug-port <port>: The port to debug on
 */
declare const start: (log: Logger, buildConfig: BuildConfig, startEnv: NodeJS.ProcessEnv, ...args: StartParam[]) => Promise<ChildProcess>;
export default start;
