import rimraf from 'rimraf';
const clean = (log, paths) => {
    if (Array.isArray(paths)) {
        return Promise.all(paths.map(path => clean(log, path)));
    }
    return new Promise((resolve, reject) => {
        rimraf(paths, err => {
            if (err) {
                log.error({ err }, 'Clean error');
                reject(err);
            }
            else {
                resolve();
            }
        });
    });
};
export default clean;
//# sourceMappingURL=index.js.map