import express from 'express';
import { Logger } from 'typescript-log';
import { getDefaultHtmlMiddleware } from './middleware/default-html-middleware';
export { getDefaultHtmlMiddleware };
export declare const getPort: (fallbackPort?: number | undefined) => number;
export declare const isWatchMode: () => boolean;
export declare const isFastMode: () => boolean;
export interface CreateServerOptions {
    log: Logger;
    /**
     * Early middleware hook is before static middleswares etc
     */
    earlyMiddlewareHook?: (app: express.Express & {
        log: Logger;
    }) => void;
    middlewareHook?: (app: express.Express & {
        log: Logger;
    }) => void;
    callback?: () => void;
    startListening?: boolean;
}
export declare type CreateServerType = (options: CreateServerOptions) => express.Express;
export declare const createServer: CreateServerType;
