import { formatElapsed } from '../../universal';
import { ServerRenderResultType } from './server-render-results';
export const createResponse = ({ renderResult, ssrRequestProps, startTime, statusCode, renderLocation, }) => {
    return {
        elapsed: formatElapsed(process.hrtime(startTime)),
        head: renderResult.head,
        renderLocation,
        renderedContent: renderResult.renderResult,
        ssrRequestProps,
        statusCode,
        type: ServerRenderResultType.Success,
    };
};
export const routerContextHandler = (renderResult, startTime, ssrRequestProps, renderLocation) => {
    if (renderResult.context.url) {
        return {
            elapsed: formatElapsed(process.hrtime(startTime)),
            head: renderResult.head,
            isPermanent: renderResult.context.statusCode === 301,
            redirectTo: renderResult.context.url,
            type: ServerRenderResultType.Redirect,
        };
    }
    const statusCode = renderResult.context.statusCode ? renderResult.context.statusCode : 200;
    return createResponse({
        renderLocation,
        renderResult,
        ssrRequestProps,
        startTime,
        statusCode,
    });
};
//# sourceMappingURL=router-context-handler.js.map