import * as tslib_1 from "tslib";
import net from 'net';
export const waitForConnection = (port, timeout = 30000) => Promise.race([
    new Promise(resolve => {
        const connect = () => {
            const socket = net.connect({ port }, () => {
                socket.end();
                resolve();
            });
            socket.on('error', () => {
                setTimeout(connect, 2000);
            });
        };
        connect();
    }),
    new Promise(resolve => setTimeout(() => resolve(), timeout)),
]);
const startPort = 3000;
export const checkPortAvailability = (port) => new Promise((resolve, reject) => {
    const server = net.createServer();
    server.on('error', () => reject());
    server.listen(port, () => {
        server.once('close', () => resolve());
        server.close();
    });
});
export const findFreePort = (useStartPort) => tslib_1.__awaiter(this, void 0, void 0, function* () {
    const testPort = useStartPort || startPort;
    for (let i = 0; i < 100; i++) {
        try {
            const port = testPort + i;
            yield checkPortAvailability(port);
            return port;
        }
        catch (e) {
            // do nothing
        }
    }
    throw new Error('Could not find a free port within 100 tries!');
});
//# sourceMappingURL=network.js.map