import * as tslib_1 from "tslib";
import { delay } from './time';
export const average = (nums) => nums.reduce((prev, cur) => prev + cur, 0) / nums.length;
export const getSequenceAverage = (log, fn, times = 5) => tslib_1.__awaiter(this, void 0, void 0, function* () {
    const results = [];
    for (let i = 0; i < times; i++) {
        try {
            const nextResult = yield fn();
            results.push(nextResult);
        }
        catch (err) {
            log.error({ err }, 'getSequenceAverage error: ');
        }
        yield delay(500);
    }
    return average(results);
});
//# sourceMappingURL=math.js.map