import * as tslib_1 from "tslib";
import { createLocation } from 'history';
import React from 'react';
import { BrowserRouter, Route } from 'react-router-dom';
import { getTransferredState } from '../../client/get-transferred-state';
var locationOverrideFromSSR = getTransferredState('watchtower_hydrate_location');
/**
 * A wrapper around React routers Browser router
 * It takes care of hydrating error routes if they happened on the server.
 * Other than initial hydration it does nothing additional
 */
var WatchtowerBrowserRouter = /** @class */ (function (_super) {
    tslib_1.__extends(WatchtowerBrowserRouter, _super);
    function WatchtowerBrowserRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WatchtowerBrowserRouter.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, props = tslib_1.__rest(_a, ["children"]);
        return (React.createElement(BrowserRouter, tslib_1.__assign({}, props),
            React.createElement(Route, { render: function (routeProps) {
                    if (!_this.initialLocation) {
                        _this.initialLocation = routeProps.location;
                    }
                    // While still on the initial route (which was hydrated), override the url
                    // if an override came from the server
                    var locationOverride = _this.initialLocation === routeProps.location && locationOverrideFromSSR
                        ? createLocation(locationOverrideFromSSR)
                        : undefined;
                    if (locationOverride) {
                        return React.createElement(Route, { location: locationOverride }, _this.props.children);
                    }
                    return React.Children.only(_this.props.children);
                } })));
    };
    WatchtowerBrowserRouter.displayName = 'WatchtowerBrowserRouter';
    return WatchtowerBrowserRouter;
}(React.Component));
export { WatchtowerBrowserRouter };
//# sourceMappingURL=watchtower-browser-router.js.map