import { Logger } from 'typescript-log';
export declare const readFileSync: (log: Logger, filePath: string) => string;
export declare const readFile: (log: Logger, filePath: string) => Promise<string>;
export declare const getFileSize: (log: Logger, filePath: string) => Promise<number>;
export declare const writeFile: (log: Logger, filePath: string, fileContent: string) => Promise<{}>;
export declare const formatFileSize: (size: number) => string;
export declare const existsSync: (file: string) => boolean;
/**
 * Dynamically require a file in a way that works both in node and from a webpack bundle
 */
export declare const dynamicRequire: (file: string) => any;
/**
 * Get custon config file if it exists as JavaScript
 * Abort with an error if it only exists as TypeScript
 * @param filePath File path from project root (without extension)
 */
export declare const getCustomConfigFile: <T extends {}>(log: Logger, root: string, filePath: string, fallback: T) => T;
