import AssetsPlugin from 'assets-webpack-plugin';
import opn from 'opn';
import webpack from 'webpack';
import webpackDevMiddleware from 'webpack-dev-middleware';
import webpackHotMiddleware from 'webpack-hot-middleware';
import { getWebpackConfig } from '../build/build';
export var getHotReloadMiddleware = function (log, buildConfig) {
    var config = getWebpackConfig(log, buildConfig, 'client', 'dev');
    if (!config) {
        throw new Error('Unable to load webpack config');
    }
    if (config.plugins) {
        config.plugins = config.plugins.filter(function (plugin) { return !(plugin instanceof AssetsPlugin); });
    }
    var compiler = webpack(config);
    var dev = webpackDevMiddleware(compiler, {
        // do not serve index.html on / route
        // https://github.com/webpack/webpack-dev-middleware/issues/153
        index: 'foobar',
        logLevel: 'silent',
        publicPath: buildConfig.PUBLIC_PATH,
        stats: 'errors-only',
    });
    var hot = webpackHotMiddleware(compiler);
    return [dev, hot];
};
export var openBrowser = function (port) {
    if (process.env.NODE_ENV === 'test') {
        return;
    }
    opn("http://localhost:" + port);
};
//# sourceMappingURL=dev.js.map