var _this = this;
import * as tslib_1 from "tslib";
import path from 'path';
import { getAbsoluteAssetPath } from '../runtime/server';
import { formatFileSize, getFileSize, readFile } from '../runtime/util/fs';
var getChunkSize = function (log, runtimeConfig, chunkPath) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    var absolutePath, size;
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                absolutePath = getAbsoluteAssetPath(runtimeConfig, chunkPath);
                return [4 /*yield*/, getFileSize(log, absolutePath)];
            case 1:
                size = _a.sent();
                return [2 /*return*/, { kb: formatFileSize(size), bytes: Math.round(size) }];
        }
    });
}); };
var bundleSize = function (log, runtimeConfig) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    var assetFilePath, assetFile, assets_1, jsAssets, cssAssets, totalJs_1, totalCss_1, values, stats, e_1;
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 3, , 4]);
                assetFilePath = path.resolve(runtimeConfig.BASE, 'assets.json');
                return [4 /*yield*/, readFile(log, assetFilePath)];
            case 1:
                assetFile = _a.sent();
                assets_1 = JSON.parse(assetFile);
                jsAssets = Object.keys(assets_1)
                    .filter(function (key) {
                    return !!assets_1[key].js;
                })
                    .map(function (key) {
                    return { js: assets_1[key].js, key: key };
                });
                cssAssets = Object.keys(assets_1)
                    .filter(function (key) {
                    return !!assets_1[key].css;
                })
                    .map(function (key) {
                    return { css: assets_1[key].css, key: key };
                });
                totalJs_1 = 0;
                totalCss_1 = 0;
                return [4 /*yield*/, Promise.all(jsAssets.map(function (jsAsset) {
                        return getChunkSize(log, runtimeConfig, jsAsset.js).then(function (size) {
                            totalJs_1 += size.bytes;
                            return {
                                asset: jsAsset.key + ".js",
                                size: size,
                            };
                        });
                    }).concat(cssAssets.map(function (cssAsset) {
                        return getChunkSize(log, runtimeConfig, cssAsset.css).then(function (size) {
                            totalCss_1 += size.bytes;
                            return {
                                asset: cssAsset.key + ".css",
                                size: size,
                            };
                        });
                    })))];
            case 2:
                values = _a.sent();
                stats = values.reduce(function (acc, val) {
                    acc["bundle_" + val.asset] = val.size.bytes.toFixed(0);
                    return acc;
                }, {});
                stats.total_js = totalJs_1.toFixed(0);
                stats.total_css = totalCss_1.toFixed(0);
                log.info(stats, 'Bundle size');
                return [2 /*return*/, stats];
            case 3:
                e_1 = _a.sent();
                log.error('Error measuring bundle sizes');
                return [2 /*return*/, {}];
            case 4: return [2 /*return*/];
        }
    });
}); };
export default bundleSize;
//# sourceMappingURL=bundle-size.js.map