var _this = this;
import * as tslib_1 from "tslib";
import path from 'path';
import { getRuntimeConfigFromBuildConfig } from '../runtime/config/config';
import { writeFile } from '../runtime/util/fs';
import bundleSize from './bundle-size';
import { lighthouseStats } from './lighthouse';
import ssrStats from './ssr-stats';
export var measureBuildStats = function (log, buildConfig, verbose) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    var runtimeConfig, bundleMetrics, ssrMetrics, lighthouseMetrics;
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                runtimeConfig = getRuntimeConfigFromBuildConfig(buildConfig);
                return [4 /*yield*/, bundleSize(log, runtimeConfig)];
            case 1:
                bundleMetrics = _a.sent();
                return [4 /*yield*/, ssrStats(log, buildConfig, verbose)];
            case 2:
                ssrMetrics = _a.sent();
                return [4 /*yield*/, lighthouseStats(log, buildConfig, verbose)];
            case 3:
                lighthouseMetrics = _a.sent();
                return [2 /*return*/, tslib_1.__assign({}, bundleMetrics, ssrMetrics, lighthouseMetrics)];
        }
    });
}); };
export var writeBuildStats = function (log, buildConfig, metrics) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    var keys, values, titleRow, valueRow, fileContent, statsFilePath;
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                // TeamCity expects key-value pairs written to the console
                Object.keys(metrics).forEach(function (key) {
                    log.info("##teamcity[buildStatisticValue key='" + key + "' value='" + metrics[key] + "']");
                });
                keys = [];
                values = [];
                Object.keys(metrics).forEach(function (key) {
                    keys.push(key);
                    values.push(metrics[key]);
                });
                titleRow = keys.join(',');
                valueRow = values.join(',');
                fileContent = titleRow + '\n' + valueRow;
                statsFilePath = path.resolve(buildConfig.BASE, 'build-stats.csv');
                return [4 /*yield*/, writeFile(log, statsFilePath, fileContent)];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
export var measureAndWriteBuildStats = function (log, buildConfig, verbose) {
    if (verbose === void 0) { verbose = false; }
    return tslib_1.__awaiter(_this, void 0, void 0, function () {
        var metrics;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, measureBuildStats(log, buildConfig, verbose)];
                case 1:
                    metrics = _a.sent();
                    return [4 /*yield*/, writeBuildStats(log, buildConfig, metrics)];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
};
//# sourceMappingURL=index.js.map