export var getTimeMs = function () {
    var hrtime = process.hrtime();
    return hrtime[0] * 1000 + hrtime[1] / 1000000;
};
export var delay = function (ms) {
    if (ms === void 0) { ms = 1000; }
    return new Promise(function (resolve) { return setTimeout(function () { return resolve(); }, ms); });
};
export var formatTimeMs = function (ms) { return ms.toFixed(0); };
export var timeout = function (promise, time) {
    var timer; // can't set to NodeJS.Timer because of webpack
    return Promise.race([
        promise,
        new Promise(function (_resolve, reject) {
            timer = setTimeout(function () { return reject(new Error("Timeout after " + time + " ms")); }, time);
        }),
    ]).then(function (result) {
        clearTimeout(timer);
        return result;
    });
};
//# sourceMappingURL=time.js.map